//+------------------------------------------------------------------+
//|                                          colored rmi             |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DeepSkyBlue
#property indicator_color2     Silver
#property indicator_color3     Silver
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_levelcolor DarkSlateGray  

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    RmiPeriod       = 14;
extern int    MomPeriod       = 5;
extern int    Price           = 8;
extern double TMSmoothing     = 5;
extern double TMDamping       = 5;
extern double TMNoise         = 30;
extern bool   Interpolate     = true;
extern bool   MultiColor      = true;
extern int    levelOb         = 70;
extern int    levelOs         = 30;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double rmi[];
double rmiUa[];
double rmiUb[];
double pos[];
double neg[];
double prc[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(7);
   SetIndexBuffer(0,rmi);
   SetIndexBuffer(1,rmiUa);
   SetIndexBuffer(2,rmiUb);
   SetIndexBuffer(3,pos);
   SetIndexBuffer(4,neg);
   SetIndexBuffer(5,prc);
   SetIndexBuffer(6,trend);
   
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
   
   //
   //
   //
   //
   //
   
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   //
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+ " tm smoothed rmi ("+RmiPeriod+","+MomPeriod+")");
   
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rmi[0] = limit+1; return(0); }

   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
   if (MultiColor && trend[limit]==-1) CleanPoint(limit,rmiUa,rmiUb);
    
      for (i=limit-1; i>=0; i--)
      {
         if (i>=Bars-MomPeriod) continue;
         
         double cu      = 0.0;
         double cd      = 0.0;
                prc[i]  = getPrice(Price,i);
         
            double diff = prc[i]-prc[i+1];
               if (diff > 0)
                     cu += diff;
               else  cd -= diff;
             
             pos[i] =(pos[i+1]*(RmiPeriod-1)+cu)/RmiPeriod;
             neg[i] =(neg[i+1]*(RmiPeriod-1)+cd)/RmiPeriod;
         
             
         
         if(neg[i] != 0.0) 
              rmi[i]= iTmSmooth(100.0 * pos[i]/(pos[i]+neg[i]),TMDamping,TMNoise,TMSmoothing,i);
         else rmi[i]= iTmSmooth(0.0,                           TMDamping,TMNoise,TMSmoothing,i);
         
           rmiUa[i] = EMPTY_VALUE;
           rmiUb[i] = EMPTY_VALUE;
           trend[i] = trend[i+1];
 
        if (rmi[i] > rmi[i+1]) trend[i]= 1;
        if (rmi[i] < rmi[i+1]) trend[i]=-1;
        if (MultiColor && trend[i]==-1) PlotPoint(i,rmiUa,rmiUb,rmi);
      
   
   }  
   manageAlerts();      
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (MultiColor && trend[limit]==-1) CleanPoint(limit,rmiUa,rmiUb);
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
       rmi[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RmiPeriod,MomPeriod,Price,TMDamping,TMNoise,TMSmoothing,0,y);
       trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RmiPeriod,MomPeriod,Price,TMDamping,TMNoise,TMSmoothing,6,y);
       rmiUa[i] = EMPTY_VALUE;
       rmiUb[i] = EMPTY_VALUE;
       
       //
       //
       //
       //
       //
      
       if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

       //
       //
       //
       //
       //

       datetime time = iTime(NULL,timeFrame,y);
          for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
          for(int k = 1; k < n; k++)
          {
               rmi[i+k] = rmi[i] + (rmi[i+n] - rmi[i]) * k/n;
               
          }               
   }               
   if (MultiColor) for (i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,rmiUa,rmiUb,rmi);
   manageAlerts();          
   return(0);
}
  
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rmi changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rmi "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrkTm[][3];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

double iTmSmooth(double price, double damping, double noise, double length, int i)
{
   if (ArrayRange(wrkTm,0) != Bars) ArrayResize(wrkTm,Bars);
   if (length<=1) return(price);
      int r = Bars-i-1;

   //
   //
   //
   //
   //

      wrkTm[r][_price] = price;

         double y1 = wrkTm[r-1][_y1];
         double y2 = wrkTm[r-1][_y2];
         
         double err = (wrkTm[r][_price]-2.0*y1+y2)/noise; 
         double drv = MathMax(MathMin((1.0/length)*err*err+(1.0/length)*MathAbs(err),0.5),0.0);
         double dmp = MathMax(MathMin((1.0/length)*MathAbs(y1-y2)/noise + damping/100.0,1.0),0.0);
         
         //
         //
         //
         //
         //
         
      double tmAvg  = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
      wrkTm[r][_y1] = tmAvg;
      wrkTm[r][_y2] = y1;
      return(tmAvg);
}   